dofile("scripts/base/util.lua")

local chatprinters = {}

local function add_chat_printer_raw(scriptname, func)
	table.insert(chatprinters, { scriptname = scriptname, f = func })
end

function load_file(category, name)
	add_chat_printer = function (func) add_chat_printer_raw(name, func) end
	if category == "chat" then
		dofile("scripts/"..name)
	end
end

local orig_text = text
dofile("scripts/loaders.lua")
dofile("scripts/user-loaders.lua")
text = orig_text

--~ print("  . . .  ")
--~ print(text)
--~ print(" -1- ")
text = "<!-- buffer br --><br>" .. text
text = text:gsub("<!%-%-lastseen:[0-9]+%-%->$", "<!-- separator:beforeA -->%0") -- lastseen at the end
text = text:gsub([[<font color=[^>]+>%b[]</font> <b><a target=mainpane href="showplayer%.php%?who=[0-9]+"><font color=[^>]+>[^<]+</font></b></a>]], "<!-- separator:beforeB --><!-- separator:startB -->%0") -- normal chat
text = text:gsub([[<font color=[^>]+>%b[]</font> <b><i><a target=mainpane href="showplayer%.php%?who=[0-9]+"><font color=[^>]+>[^<]+</b></font></a>]], "<!-- separator:beforeC --><!-- separator:startC -->%0") -- emote in chat
text = text:gsub([[<br>(<b><a target=mainpane href="showplayer%.php%?who=[0-9]+"><font color=[^>]+>[^<]+</font></b></a>)]], "<br><!-- separator:beforeD --><!-- separator:startD -->%1") -- normal chat
text = text:gsub([[<br>(<b><i><a target=mainpane href="showplayer%.php%?who=[0-9]+"><font color=[^>]+>[^<]+</b></font></a>)]], "<br><!-- separator:beforeE --><!-- separator:startE -->%1") -- emote in chat
text = text:gsub([[<a target=mainpane href="showplayer%.php%?who=[0-9]+"><font color=[^>]+><b>[^<]+</b></a>]], "<!-- separator:beforeF --><!-- separator:startF -->%0") -- private message
--~ print(text)
--~ print(" -2- ")
text = text:gsub("<!%-%- separator:start[A-Z] %-%->(.-)<!%-%- separator:before[A-Z] %-%->", function (msg)
--~  	print("chatmsg", msg)
	for _, printer in pairs(chatprinters) do
		msg = printer.f(msg)
--~  		print("stepmsg", msg, printer.scriptname)
	end
--~  	print("becamsg", msg)
	return msg
end)
--~ print(" -3- ")
text = string.gsub(text, "<!%-%- separator:[a-zA-Z]+ %-%->", "")
text = string.gsub(text, "^<!%-%- buffer br %-%-><br>", "")
--~ print(text)
--~ print("  . . .  ")

--~ text = orig_text

return text
